diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/uan/model/uan-phy-dual.cc ns-3.43/src/uan/model/uan-phy-dual.cc
--- ns-3.42/src/uan/model/uan-phy-dual.cc	2024-05-29 15:29:47.184073700 -0700
+++ ns-3.43/src/uan/model/uan-phy-dual.cc	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Leonard Tracy <lentracy@gmail.com>
  *         Andrea Sacco <andrea.sacco85@gmail.com>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/uan/model/uan-phy-dual.h ns-3.43/src/uan/model/uan-phy-dual.h
--- ns-3.42/src/uan/model/uan-phy-dual.h	2024-05-29 15:29:47.184073700 -0700
+++ ns-3.43/src/uan/model/uan-phy-dual.h	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Leonard Tracy <lentracy@gmail.com>
  *         Andrea Sacco <andrea.sacco85@gmail.com>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/uan/model/uan-phy-gen.cc ns-3.43/src/uan/model/uan-phy-gen.cc
--- ns-3.42/src/uan/model/uan-phy-gen.cc	2024-05-29 15:29:47.184073700 -0700
+++ ns-3.43/src/uan/model/uan-phy-gen.cc	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Leonard Tracy <lentracy@gmail.com>
  *         Andrea Sacco <andrea.sacco85@gmail.com>
@@ -310,7 +299,7 @@
     // Amplitude Modulation", EE 242 Digital Communications and Codings, 2009
     case UanTxMode::QAM: {
         // generic EbNo
-        EbNo *= mode.GetDataRateBps() / mode.GetBandwidthHz();
+        EbNo *= static_cast<double>(mode.GetBandwidthHz()) / mode.GetDataRateBps();
 
         auto M = (double)mode.GetConstellationSize();
 
@@ -345,8 +334,8 @@
             // Eq (74)
             for (int j = 0; j < sum_items; ++j)
             {
-                PbK += ::std::pow(-1.0, (double)j * pow2k / sqrtM) *
-                       (pow2k - ::std::floor((double)(j * pow2k / sqrtM) - 0.5)) *
+                PbK += ::std::pow(-1.0, ::std::floor((double)j * pow2k / sqrtM)) *
+                       (pow2k - ::std::floor((double)(j * pow2k / sqrtM) + 0.5)) *
                        erfc((2.0 * (double)j + 1.0) *
                             ::std::sqrt(3.0 * (log2M * EbNo) / (2.0 * (M - 1.0))));
 
@@ -857,9 +846,10 @@
     else
     {
         m_state = IDLE;
-        UpdatePowerConsumption(IDLE);
     }
 
+    UpdatePowerConsumption(IDLE);
+
     if (m_pg->GetValue(0, 1) > m_per->CalcPer(m_pktRx, m_minRxSinrDb, txMode))
     {
         m_rxOkLogger(pkt, m_minRxSinrDb, txMode);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/uan/model/uan-phy-gen.h ns-3.43/src/uan/model/uan-phy-gen.h
--- ns-3.42/src/uan/model/uan-phy-gen.h	2024-05-29 15:29:47.184073700 -0700
+++ ns-3.43/src/uan/model/uan-phy-gen.h	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Leonard Tracy <lentracy@gmail.com>
  *         Andrea Sacco <andrea.sacco85@gmail.com>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/uan/model/uan-phy.h ns-3.43/src/uan/model/uan-phy.h
--- ns-3.42/src/uan/model/uan-phy.h	2024-05-29 15:29:47.184073700 -0700
+++ ns-3.43/src/uan/model/uan-phy.h	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Leonard Tracy <lentracy@gmail.com>
  *         Andrea Sacco <andrea.sacco85@gmail.com>
@@ -282,6 +271,7 @@
      *
      * \param thresh Threshold SINR for proper reception in dB re 1 uPa.
      */
+    // NS_DEPRECATED() - tag for future removal
     virtual void SetRxThresholdDb(double thresh) = 0;
 
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/uan/model/uan-prop-model.cc ns-3.43/src/uan/model/uan-prop-model.cc
--- ns-3.42/src/uan/model/uan-prop-model.cc	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/uan/model/uan-prop-model.cc	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Leonard Tracy <lentracy@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/uan/model/uan-prop-model.h ns-3.43/src/uan/model/uan-prop-model.h
--- ns-3.42/src/uan/model/uan-prop-model.h	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/uan/model/uan-prop-model.h	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Leonard Tracy <lentracy@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/uan/model/uan-prop-model-ideal.cc ns-3.43/src/uan/model/uan-prop-model-ideal.cc
--- ns-3.42/src/uan/model/uan-prop-model-ideal.cc	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/uan/model/uan-prop-model-ideal.cc	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Leonard Tracy <lentracy@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/uan/model/uan-prop-model-ideal.h ns-3.43/src/uan/model/uan-prop-model-ideal.h
--- ns-3.42/src/uan/model/uan-prop-model-ideal.h	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/uan/model/uan-prop-model-ideal.h	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Leonard Tracy <lentracy@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/uan/model/uan-prop-model-thorp.cc ns-3.43/src/uan/model/uan-prop-model-thorp.cc
--- ns-3.42/src/uan/model/uan-prop-model-thorp.cc	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/uan/model/uan-prop-model-thorp.cc	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Leonard Tracy <lentracy@gmail.com>
  */
@@ -93,7 +82,7 @@
     }
     else
     {
-        atten = 0.002 + 0.11 * (freqKhz / (1 + freqKhz)) + 0.011 * freqKhz;
+        atten = 0.002 + 0.11 * (fsq / (1 + fsq)) + 0.011 * fsq;
     }
 
     return atten;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/uan/model/uan-prop-model-thorp.h ns-3.43/src/uan/model/uan-prop-model-thorp.h
--- ns-3.42/src/uan/model/uan-prop-model-thorp.h	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/uan/model/uan-prop-model-thorp.h	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Leonard Tracy <lentracy@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/uan/model/uan-transducer.cc ns-3.43/src/uan/model/uan-transducer.cc
--- ns-3.42/src/uan/model/uan-transducer.cc	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/uan/model/uan-transducer.cc	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2011 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mitch Watrous <watrous@u.washington.edu>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/uan/model/uan-transducer.h ns-3.43/src/uan/model/uan-transducer.h
--- ns-3.42/src/uan/model/uan-transducer.h	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/uan/model/uan-transducer.h	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Leonard Tracy <lentracy@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/uan/model/uan-transducer-hd.cc ns-3.43/src/uan/model/uan-transducer-hd.cc
--- ns-3.42/src/uan/model/uan-transducer-hd.cc	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/uan/model/uan-transducer-hd.cc	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Leonard Tracy <lentracy@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/uan/model/uan-transducer-hd.h ns-3.43/src/uan/model/uan-transducer-hd.h
--- ns-3.42/src/uan/model/uan-transducer-hd.h	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/uan/model/uan-transducer-hd.h	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Leonard Tracy <lentracy@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/uan/model/uan-tx-mode.cc ns-3.43/src/uan/model/uan-tx-mode.cc
--- ns-3.42/src/uan/model/uan-tx-mode.cc	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/uan/model/uan-tx-mode.cc	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Leonard Tracy <lentracy@gmail.com>
  */
@@ -273,7 +262,7 @@
 std::istream&
 operator>>(std::istream& is, UanModesList& ml)
 {
-    char c;
+    char c = '\0';
 
     int numModes;
 
@@ -281,18 +270,30 @@
     if (c != '|')
     {
         is.setstate(std::ios_base::failbit);
+        return is;
     }
     ml.m_modes.clear();
     ml.m_modes.resize(numModes);
 
-    for (int i = 0; i < numModes && !is.eof(); i++)
+    if (numModes == 0 && is.peek() == std::istream::traits_type::eof())
+    {
+        return is;
+    }
+
+    int i;
+    for (i = 0; is.peek() != std::istream::traits_type::eof() && i < numModes; i++)
     {
         is >> ml.m_modes[i] >> c;
         if (c != '|')
         {
             is.setstate(std::ios_base::failbit);
+            return is;
         }
     }
+    if (i < numModes)
+    {
+        is.setstate(std::ios_base::failbit);
+    }
 
     return is;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/uan/model/uan-tx-mode.h ns-3.43/src/uan/model/uan-tx-mode.h
--- ns-3.42/src/uan/model/uan-tx-mode.h	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/uan/model/uan-tx-mode.h	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Leonard Tracy <lentracy@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/uan/test/uan-energy-model-test.cc ns-3.43/src/uan/test/uan-energy-model-test.cc
--- ns-3.42/src/uan/test/uan-energy-model-test.cc	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/uan/test/uan-energy-model-test.cc	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2010 Andrea Sacco
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Andrea Sacco <andrea.sacco85@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/uan/test/uan-test.cc ns-3.43/src/uan/test/uan-test.cc
--- ns-3.42/src/uan/test/uan-test.cc	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/uan/test/uan-test.cc	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Leonard Tracy <lentracy@gmail.com>
  */
@@ -314,6 +303,91 @@
  * \ingroup uan-test
  * \ingroup tests
  *
+ * \brief UanModesList Test
+ */
+class UanModesListTest : public TestCase
+{
+  public:
+    UanModesListTest();
+
+    void DoRun() override;
+};
+
+UanModesListTest::UanModesListTest()
+    : TestCase("UanModesListTest")
+{
+}
+
+void
+UanModesListTest::DoRun()
+{
+    // operator >> (std::istream &is, UanModesList &ml)
+    std::string inputStr;
+    std::istringstream iss;
+    UanModesList ml;
+
+    inputStr = "3|0|1|1|";
+    iss.str(inputStr);
+    iss >> ml;
+    NS_TEST_ASSERT_MSG_EQ(ml.GetNModes(), 3, "Expected 3 modes in the list");
+    NS_TEST_ASSERT_MSG_EQ(iss.eof(), true, "Expected end of file state");
+    NS_TEST_ASSERT_MSG_EQ(iss.fail(), false, "Expected no fail state");
+
+    inputStr = "3|0|1|";
+    iss.str(inputStr);
+    iss.clear();
+    iss >> ml;
+    NS_TEST_ASSERT_MSG_EQ(iss.fail(), true, "Expected fail state due to incomplete input");
+
+    inputStr = "|3|0|1|1|";
+    iss.str(inputStr);
+    iss.clear();
+    iss >> ml;
+    NS_TEST_ASSERT_MSG_EQ(iss.fail(), true, "Expected fail state due to leading delimiter");
+
+    inputStr = "3|0|1|1|0|";
+    iss.str(inputStr);
+    iss.clear();
+    iss >> ml;
+    NS_TEST_ASSERT_MSG_EQ(iss.eof(), false, "Expected no end of file state");
+
+    inputStr = "0|";
+    iss.str(inputStr);
+    iss.clear();
+    iss >> ml;
+    NS_TEST_ASSERT_MSG_EQ(ml.GetNModes(), 0, "Expected 0 modes in the list");
+    NS_TEST_ASSERT_MSG_EQ(iss.eof(), true, "Expected end of file state");
+    NS_TEST_ASSERT_MSG_EQ(iss.fail(), false, "Expected no fail state");
+
+    inputStr = "0|1|0|";
+    iss.str(inputStr);
+    iss.clear();
+    iss >> ml;
+    NS_TEST_ASSERT_MSG_EQ(iss.eof(), false, "Expected end of file state");
+
+    inputStr = "a|1|2|";
+    iss.str(inputStr);
+    iss.clear();
+    iss >> ml;
+    NS_TEST_ASSERT_MSG_EQ(iss.fail(), true, "Expected fail state due to non-numeric input");
+
+    inputStr = "a|b|c|";
+    iss.str(inputStr);
+    iss.clear();
+    iss >> ml;
+    NS_TEST_ASSERT_MSG_EQ(iss.fail(), true, "Expected fail state due to non-numeric input");
+
+    inputStr = "3|a|b|c|";
+    iss.str(inputStr);
+    iss.clear();
+    iss >> ml;
+    NS_TEST_ASSERT_MSG_EQ(iss.fail(), true, "Expected fail state due to non-numeric input");
+}
+
+/**
+ * \ingroup uan-test
+ * \ingroup tests
+ *
  * \brief Uan Test Suite
  */
 class UanTestSuite : public TestSuite
@@ -326,6 +400,7 @@
     : TestSuite("devices-uan", Type::UNIT)
 {
     AddTestCase(new UanTest, TestCase::Duration::QUICK);
+    AddTestCase(new UanModesListTest, TestCase::Duration::QUICK);
 }
 
 static UanTestSuite g_uanTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/virtual-net-device/examples/virtual-net-device-example.cc ns-3.43/src/virtual-net-device/examples/virtual-net-device-example.cc
--- ns-3.42/src/virtual-net-device/examples/virtual-net-device-example.cc	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/virtual-net-device/examples/virtual-net-device-example.cc	2024-10-09 16:41:10.104656700 -0700
@@ -1,16 +1,5 @@
 /*
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Based on simple-global-routing.cc
  * The Tunnel class adds two tunnels, n0<=>n3 and n1<=>n3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/virtual-net-device/model/virtual-net-device.cc ns-3.43/src/virtual-net-device/model/virtual-net-device.cc
--- ns-3.42/src/virtual-net-device/model/virtual-net-device.cc	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/virtual-net-device/model/virtual-net-device.cc	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2008,2009 INESC Porto
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author:  Gustavo J. A. M. Carneiro  <gjc@inescporto.pt>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/virtual-net-device/model/virtual-net-device.h ns-3.43/src/virtual-net-device/model/virtual-net-device.h
--- ns-3.42/src/virtual-net-device/model/virtual-net-device.h	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/virtual-net-device/model/virtual-net-device.h	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2008,2009 INESC Porto
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Gustavo J. A. M. Carneiro  <gjc@inescporto.pt>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/visualizer/model/pyviz.cc ns-3.43/src/visualizer/model/pyviz.cc
--- ns-3.42/src/visualizer/model/pyviz.cc	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/visualizer/model/pyviz.cc	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2008 INESC Porto
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Gustavo Carneiro  <gjc@inescporto.pt>
  */
